from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC
from cpl_query.extension import List


class DiscordAuthenticationSettings(ConfigurationModelABC):
    def __init__(
        self,
        client_secret: str = None,
        redirect_uri: str = None,
        scope: list = None,
        token_url: str = None,
        auth_url: str = None,
    ):
        ConfigurationModelABC.__init__(self)

        self._client_secret = "" if client_secret is None else client_secret
        self._redirect_url = "" if redirect_uri is None else redirect_uri
        self._scope = List() if scope is None else List(str, scope)
        self._token_url = "" if token_url is None else token_url
        self._auth_url = "" if auth_url is None else auth_url

    @property
    def client_secret(self) -> str:
        return self._client_secret

    @property
    def redirect_url(self) -> str:
        return self._redirect_url

    @property
    def scope(self) -> List[str]:
        return self._scope

    @property
    def token_url(self) -> str:
        return self._token_url

    @property
    def auth_url(self) -> str:
        return self._auth_url
