ALTER TABLE `UserJoinedGameServer`
    CHANGE `CreatedAt` `CreatedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `UserJoinedGameServer`
    CHANGE `LastModifiedAt` `LastModifiedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `UserJoinedGameServerHistory`
(
    `Id`           BIGINT(20)  NOT NULL,
    `UserId`       BIGINT(20)  NOT NULL,
    `GameServerId` BIGINT(20)  NOT NULL,
    `JoinedOn`     DATETIME(6) NOT NULL,
    `LeavedOn`     DATETIME(6) DEFAULT NULL,
    `Deleted`      BOOL        DEFAULT FALSE,
    `DateFrom`     DATETIME(6) NOT NULL,
    `DateTo`       DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_UserJoinedGameServerUpdate`;

CREATE TRIGGER `TR_UserJoinedGameServerUpdate`
    AFTER UPDATE
    ON `UserJoinedGameServer`
    FOR EACH ROW
BEGIN
    INSERT INTO `UserJoinedGameServerHistory` (
        `Id`, `UserId`, `GameServerId`, `JoinedOn`, `LeavedOn`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.UserId, OLD.GameServerId, OLD.JoinedOn, OLD.LeavedOn, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_UserJoinedGameServerDelete`;

CREATE TRIGGER `TR_UserJoinedGameServerDelete`
    AFTER DELETE
    ON `UserJoinedGameServer`
    FOR EACH ROW
BEGIN
    INSERT INTO `UserJoinedGameServerHistory` (
        `Id`, `UserId`, `GameServerId`, `JoinedOn`, `LeavedOn`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.UserId, OLD.GameServerId, OLD.JoinedOn, OLD.LeavedOn, TRUE, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;