ALTER TABLE `Users`
    CHANGE `CreatedAt` `CreatedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `Users`
    CHANGE `LastModifiedAt` `LastModifiedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `UsersHistory`
(
    `Id`            BIGINT(20)  NOT NULL,
    `DiscordId`     BIGINT(20)  NOT NULL,
    `XP`            BIGINT(20)  NOT NULL DEFAULT 0,
    `ReactionCount` BIGINT(20)  NOT NULL DEFAULT 0,
    `MessageCount`  BIGINT(20)  NOT NULL DEFAULT 0,
    `Birthday`      DATE        NULL,
    `ServerId`      BIGINT(20)           DEFAULT NULL,
    `Deleted`       BOOL                 DEFAULT FALSE,
    `DateFrom`      DATETIME(6) NOT NULL,
    `DateTo`        DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_UsersUpdate`;

CREATE TRIGGER `TR_UsersUpdate`
    AFTER UPDATE
    ON `Users`
    FOR EACH ROW
BEGIN
    INSERT INTO `UsersHistory` (`Id`, `DiscordId`, `XP`, `ReactionCount`, `MessageCount`, `Birthday`, `ServerId`,
                                `DateFrom`, `DateTo`)
    VALUES (OLD.UserId, OLD.DiscordId, OLD.XP, OLD.ReactionCount, OLD.MessageCount, OLD.Birthday, OLD.ServerId,
            OLD.LastModifiedAt, CURRENT_TIMESTAMP(6));
END;

DROP TRIGGER IF EXISTS `TR_UsersDelete`;

CREATE TRIGGER `TR_UsersDelete`
    AFTER DELETE
    ON `Users`
    FOR EACH ROW
BEGIN
    INSERT INTO `UsersHistory` (`Id`, `DiscordId`, `XP`, `ReactionCount`, `MessageCount`, `Birthday`, `ServerId`,
                                `Deleted`, `DateFrom`, `DateTo`)
    VALUES (OLD.UserId, OLD.DiscordId, OLD.XP, OLD.ReactionCount, OLD.MessageCount, OLD.Birthday, OLD.ServerId, TRUE,
            OLD.LastModifiedAt, CURRENT_TIMESTAMP(6));
END;