from datetime import datetime
from typing import Optional

from cpl_core.database import TableABC

from bot_data.model.user import User


# had to name it UserWarnings instead of UserWarning because UserWarning is a builtin class
class UserWarnings(TableABC):
    def __init__(
        self,
        description: str,
        user: User,
        author: Optional[User],
        created_at: datetime = None,
        modified_at: datetime = None,
        id=0,
    ):
        self._id = id
        self._description = description
        self._user = user
        self._author = author

        TableABC.__init__(self)
        self._created_at = created_at if created_at is not None else self._created_at
        self._modified_at = modified_at if modified_at is not None else self._modified_at

    @property
    def id(self) -> int:
        return self._id

    @property
    def description(self) -> str:
        return self._description

    @property
    def user(self) -> User:
        return self._user

    @property
    def author(self) -> Optional[User]:
        return self._author

    @staticmethod
    def get_select_all_string() -> str:
        return str(
            f"""
                SELECT * FROM `UserWarnings`;
            """
        )

    @staticmethod
    def get_select_by_id_string(id: int) -> str:
        return str(
            f"""
                SELECT * FROM `UserWarnings`
                WHERE `Id` = {id};
            """
        )

    @staticmethod
    def get_select_by_user_id_string(id: int) -> str:
        return str(
            f"""
                SELECT * FROM `UserWarnings`
                WHERE `UserId` = {id};
            """
        )

    @property
    def insert_string(self) -> str:
        return str(
            f"""
            INSERT INTO `UserWarnings` (
                `Description`, `UserId`, `Author`
            ) VALUES (
                '{self._description}',
                {self._user.id},
                {"NULL" if self._author is None else f"{self._author.id}"}
            );
            """
        )

    @property
    def udpate_string(self) -> str:
        return str(
            f"""
            UPDATE `UserWarnings`
            SET `Description` = '{self._description}'
            WHERE `Id` = {self._id};
            """
        )

    @property
    def delete_string(self) -> str:
        return str(
            f"""
            DELETE FROM `UserWarnings`
            WHERE `Id` = {self._id};
            """
        )
