from cpl_core.database.context import DatabaseContextABC
from cpl_core.dependency_injection import ServiceProviderABC

from bot_core.logging.database_logger import DatabaseLogger
from bot_data.abc.data_seeder_abc import DataSeederABC


class SeederService:
    def __init__(
        self,
        logger: DatabaseLogger,
        services: ServiceProviderABC,
        db: DatabaseContextABC,
    ):
        self._logger = logger
        self._services = services

        self._db = db

    async def seed(self):
        self._logger.info(__name__, f"Seed data")
        for seeder in self._services.get_services(DataSeederABC):
            seeder: DataSeederABC = seeder
            self._logger.debug(__name__, f"Starting seeder {type(seeder).__name__}")
            await seeder.seed()
            self._db.save_changes()
