from cpl_core.database.context import DatabaseContextABC

from bot_data.model.achievement_history import AchievementHistory
from bot_graphql.abc.data_query_with_history_abc import DataQueryWithHistoryABC


class AchievementQuery(DataQueryWithHistoryABC):
    def __init__(
        self,
        db: DatabaseContextABC,
    ):
        DataQueryWithHistoryABC.__init__(self, "Achievement", "AchievementsHistory", AchievementHistory, db)

        self.set_field("id", lambda x, *_: x.id)
        self.set_field("name", lambda x, *_: x.name)
        self.set_field("description", lambda x, *_: x.description)
        self.set_field("attribute", lambda x, *_: x.attribute)
        self.set_field("operator", lambda x, *_: x.operator)
        self.set_field("value", lambda x, *_: x.value)
        self.set_field("server", lambda x, *_: x.server)
