import { Directive, HostBinding, Input } from "@angular/core";
import { ComponentWithTable } from "../../../base/component-with-table";

@Directive()
export class HideableComponent {
  @HostBinding("class.hidden-column")
  get hidden() {
    const column = this.subColumn ?? this.column;
    return !(this.parent?.isColumnVisible(column) ?? true);
  };

  @Input() column!: string;
  @Input() subColumn!: string;
  @Input() parent!: ComponentWithTable;
}
